/** Framework Resposável pelo Banckend */
let express = require('express')

/** Carrega as configurações de ambiente */
let environment = require('./modules/environment')

const start = () => {
	/** Instância da aplicação BACKEND */
	let app = express()
	let port = 3031//environment.webserver.port
	
	/** Servidor HTTP do Node */
	let server = require('http').createServer(app)
	
	/** Traduzir as requisições para JSON */
	app.use(require('body-parser').json())
	
	/** Rota de apresentação da API */
	app.get('/api/v1/', function(req, res){
		mensagem = `
			<style>
			.msg_center {
				width: 100%;
				height: 100%;
				display: flex;
				justify-content: center;
				align-items: center;
				font-size: 2.5vw;
			}
			</style>
			<div class="msg_center">
				<pre>PSD - Api v2.0.0</pre>
			</div>
		`
		res.send(mensagem)
	})
	
	/** Rota de autenticação */
	app.post('/api/v1/auth',(req,res) => {
		msg = req.body
		res.send( msg )
	})
	
	app.post('/receiveSnapshot/', (req, res) => {
		res.send('ok')
	})
	
	app.post('/receive/', (req, res) => {
		res.send('ok')
		io.emit('message', JSON.stringify(req.body) )
	})
	
	/** socket.io */
	let io = require('socket.io')(server)
	
	io.on('connection', client => {
		client.emit('message', 'hello')
		console.log('Conexão recebida');
	})
	
	app.use(express.static('./mockfront/'));
	
	/** Subir o servidor na porta setada */
	server.listen(port, function(){
		console.log(`This server is running on ${port}`)
	})
}

module.exports = { start }